/*#####rrmsb_fieldbuttons.js, installed by ###Field Buttons, by Robin Richmond*/
/*This Javascript Library implements "Field Buttons" in TNG web pages.
For detailed information about Field Buttons, see
- The "Field Buttons" article in the TNG Wiki,
- The Microsoft Word document FieldButtons.doc in the Field Buttons mod subfolder
- A commented variant of this file, rrms_fieldbuttons_commented.js,also in the mod subfolder.
*/
var rrButtonsLabels = "X,R,D,A";
var rrButtonsMap = Array();
var rrButtonsMap2 = Array();
var rrButtonsFlags = '1,1,1,1';
var rrButtonsValues = Array();
var rrButtonsDocumentReadyFunctions = Array();
var rrButtonsFinalSetupFunctions = Array();
var rrButtonsOnClickFunctions = Array();

/////////////////////////External function
function rrButtonsSystemSettings (theLabels, theFlags) {
	if (theLabels) rrButtonsLabels = theLabels;
	if (theFlags) rrButtonsFlags = theFlags;
}
/////////////////////////External function
function rrButtonsPushFunction (beforeOrAfter, theFunction, fieldID) {
	if (beforeOrAfter == 'before')
		rrButtonsDocumentReadyFunctions.push(theFunction);
	else if (beforeOrAfter == 'after')
		rrButtonsFinalSetupFunctions.push(theFunction);
	else rrButtonsOnClickFunctions[fieldID].push(theFunction);
}
/////////////////////////External function
function rrButtonsSetValue (fieldID, buttonType, theValue) {
	rrButtonsValues[fieldID][buttonType] = theValue;
}
/////////////////////////External function
function rrButtonsSetVisibilityAll () {
	$('.rrbtnx,.rrbtnr,.rrbtnd,.rrbtna').each(function() {
		fieldID = $(this).attr('id');
		rrButtonsSetVisibility(fieldID);
	});
}
/////////////////////////External function; also used internally
function rrButtonsSetVisibility(fieldID) {
	var buttonValue;
	var hashid = '#'+fieldID+'rrfb'; //Prefix for field button id's
	var fieldval = $('#'+fieldID).val()

	for (btype in rrButtonsValues[fieldID]) {
		buttonValue = rrButtonsMap[btype];
		if (rrButtonsValues[fieldID][btype] != fieldval) {
			$(hashid+btype).html(rrButtonsMap[btype]);
			$(hashid+btype).css('padding','0');
			$(hashid+btype).css('border-width','1');
		} else {
			buttonValue = '~~~~~~~~~~~~~~~'.substr(0,rrButtonsMap[btype].length).replace(/~/g,'&nbsp;')
			$(hashid+btype).html(buttonValue);
			$(hashid+btype).css('padding','1');
			$(hashid+btype).css('border-width','0');
		}
	}
}

//////////////////////Legacy external functions (superseded by rrButtonsSystemSettings)
function rrButtonsSetLabels(theLabels) {
	rrButtonsLabels = theLabels;
}
function rrButtonsSetFlags(theFlags) {
	rrButtonsFlags = theFlags;
}
//////////////////////Legacy external functions (superseded by rrButtonsDisplayToggle)
function rrButtonsDisplayToggle(fieldID) {
	rrButtonsSetVisibility(fieldID);
}
function toggleFieldButtons(fieldID) {
	rrButtonsSetVisibility(fieldID);
}

///////////// document.ready /////////////////
$(function() {
	for (ii=0; ii<rrButtonsDocumentReadyFunctions.length; ii++)
		rrButtonsDocumentReadyFunctions[ii]();
	$('.rrbtnx,.rrbtnr,.rrbtnd,.rrbtna').each(function() {
		var fieldID = $(this).attr('id');
		rrButtonsValues[fieldID] = Array();
		rrButtonsOnClickFunctions[fieldID] = Array();
	});
	for (rr=0; rr<rrButtonsFinalSetupFunctions.length; rr++)
		rrButtonsFinalSetupFunctions[rr]();
	rrButtonsCreateThem();
});

/////////////// internal function
function rrButtonsCreateThem() {
	if (rrButtonsFlags == '0,0,0,0') return;
	if (rrButtonsFlags.trim() == '') rrButtonsFlags='1,1,1,1';
	var textArea = document.createElement('textarea');
	textArea.innerHTML = rrButtonsLabels;
	rrButtonsLabels = textArea.value.split(',');
	rrButtonsFlags = rrButtonsFlags.split(',');
	for (bb=0; bb<4; bb++)
		if (!rrButtonsFlags[bb]) rrButtonsLabels[bb] = 0;
	for (id in rrButtonsValues) {
		if (!rrButtonsLabels[2]) rrButtonsValues[id]['D'] = Array();
		if (!rrButtonsLabels[3]) rrButtonsValues[id]['A'] = Array();
	}
	rrButtonsMap['X'] = rrButtonsLabels[0];
	rrButtonsMap['R'] = rrButtonsLabels[1];
	rrButtonsMap['D'] = rrButtonsLabels[2];
	rrButtonsMap['A'] = rrButtonsLabels[3];
	rrButtonsMap2[rrButtonsMap['X']] = 'X';
	rrButtonsMap2[rrButtonsMap['R']] = 'R';
	rrButtonsMap2[rrButtonsMap['D']] = 'D';
	rrButtonsMap2[rrButtonsMap['A']] = 'A';

	$('.rrbtnx,.rrbtnr,.rrbtnd,.rrbtna').each(function() {
		var id = $(this).attr('id');
		$(this).on('change', function(event) {
			rrButtonsSetVisibility(event.target.id);
			return false;
		});
		$(this).wrap("<span class='nw normal'></span>")
		var html = '';
		var buttonTemplate = "<span style='cursor:pointer;' class='rrbtn' id='" +id+ "rrfbXXX'></span>";
		if ($(this).hasClass('rrbtnx') && rrButtonsLabels[0]) {
			html += buttonTemplate.replace('XXX','X');
			//X buttons will always store '' in the field.
			rrButtonsValues[id]['X'] = '';
		}
		if ($(this).hasClass('rrbtnr') && rrButtonsLabels[1]) {
			html += buttonTemplate.replace('XXX','R');
		}
		//The R button will always store the intial field value in the field.
		//Even when the button is undefined!!!
		rrButtonsValues[id]['R'] = $(this).val();
		if ($(this).hasClass('rrbtnd') && rrButtonsLabels[2] &&
			!($(this).hasClass('rrbtna') && rrButtonsLabels[3]
				&& rrButtonsValues[id]['D'] == rrButtonsValues[id]['A'] )) {
			html += buttonTemplate.replace('XXX','D');
		}
		if ($(this).hasClass('rrbtna') && rrButtonsLabels[3]) {
			html += buttonTemplate.replace('XXX','A');
		}
		$(this).after(html);
		if ($(this).prop('tagName') == 'TEXTAREA')
			//$(this).parent().css('display','inline-block').css('vertical-align':'top');
			$(this).parent().children().css('display','inline-block').css('vertical-align','top');
		rrButtonsSetVisibility(id);
	});

	$('.rrbtn').on('click', function(event) {
		var id = event.target.id.slice(0,-5);
		var label = $(this).html();
		if (label == '&nbsp;') return false;
		label = rrButtonsMap2[label];
		if (label in rrButtonsValues[id])
			$('#'+id).val(rrButtonsValues[id][label]);
		if (id in rrButtonsOnClickFunctions) {
			for (ii=0; ii<rrButtonsOnClickFunctions[id].length; ii++)
				rrButtonsOnClickFunctions[id][ii]();
		}
		//Set the display status of each of this form field's Field Buttons.
		rrButtonsSetVisibility(id);
		return false;
	});
}