/*
##### rrmsb_lib.js, installed by ###Mod Settings Blocks, by Robin Richmond
### See the Inner Mod Menus documentation in the mod's subfolder.
*/
//////////////////////////////////////////////////
/// document.ready function
$(function () {
	var numMods = $('.rrimmMenu').length;
	if (!numMods || (rrconfig['MSB-IMMLocation'] != 'innermenu' && rrconfig['MSB-IMMLocation'] != "footer"))
		return; //**********************no menus to see or don't show menus => Early exit

	//Put the various Inner Mod Menus in an array that can be sorted by modname
	var menuArray1 = Array(); //primary mods
	var menuArray2 = Array(); //secondary mods
	$('.rrimmMenu').each (function() {
		if (numMods<6 || !Number($(this).attr('secondary')))
			menuArray1.push($(this).html());
		else menuArray2.push($(this).html());
		$(this).remove();
	});
	//Add each menu to an HTML string
	var html = '';
	var modCount1 = menuArray1.length;
	menuArray1.sort();
	for (i=0; i<modCount1; i++)
		html += menuArray1[i];
	var modCount2 = menuArray2.length
	if (modCount2) {
		html += "<b><a href='#' class='more rrimmlink' onclick='rrimmMoreClick(event);'>" + rrconfig['rrimm-moremods'] + "</a></b>";
		html += "<b><a href='#' class='more rrimmlink' onclick='rrimmMoreClick(event);' style='display:none;'>" + rrconfig['rrimm-fewermods'] + "</a></b>";
		html += "<div class='more' style='display:none;'>";
		menuArray2.sort();
		for (i=0; i<modCount2; i++)
			html += menuArray2[i];
		html += "</div>";
	}
	//Add the InnerModMenu wrapper to the appropriate Inner menu.
	//Figure out the ID of this program's Inner menu.
	var rrimmMenuID,rrimmAdminNote, labelButton;
	if (rrconfig['MSB-IMMLocation'] == "innermenu") {
		if ($('#adm-innermenu').length) { //Admin program
			rrimmMenuID = '#adm-innermenu';
			rrimmAdminNote = '';
		} else { //End-user program
			rrimmMenuID = '#pub-innermenu';
			rrimmAdminNote = rrconfig['rrim-onlyadmins'];
		}
		labelClass = "lightlink";
	} else { // (rrconfig['MSB-IMMLocation'] == "footer")
		if ($('#rrImmFooterAdmin').length) { //Admin program
			rrimmMenuID = '#rrImmFooterAdmin';
			rrimmAdminNote = '';
		} else { //End-user program
			rrimmMenuID = '#rrImmFooterPublic';
			rrimmAdminNote = rrconfig['rrimm-onlyadmins'];
		}
		labelClass = "snlink"; 
	} // end IF location 

	//Build a wrapper around the Inner Mod Menu html, and add it to the Inner Menu
	var wrapHtml = "<div id='rrimmMenu'>"
	+ "<a href='#' onclick='return false;' class='" + labelClass + "' "
	+ "title='" + rrimmAdminNote + "'>" + rrconfig['InnermenuLabel'] + "</a>\n"
	+ "<div id='rrimmDrop' class='slidedown'>"
	+ "<img src='img/tng_close.gif' class='rrimmMenuX' border='0' alt=''>"
	+ "</div></div>";

	//Add the menu structure to the appropriate div
	$(rrimmMenuID).append(wrapHtml);
	//Add the InnerModMenu contents to the wrapper inside the menu structure
	$('#rrimmDrop').append(html);

	//Define the height of the InnerModMenu, based on the count of lines (<br> tags) in the content.
	var rrNumLines = html.split('<br>').length;

	//Onclick function to toggle the display of the InnerModMenu when the user clicks
	//on any part of the menu that is not a hyperlink. This is the only way to
	//open or close the menu. When the menu is closed, only the menu's label is visible.
	//When the menu is open, its X does not need to explictly clicked to close the menu,
	//since the X is simply part of the menu div.
	$('#rrimmMenu').click(function () {
		$('#rrimmDrop').slideToggle(200);
		return false;
	});
}); //end document.ready function

//////////////////////////////////////////////////
//Function that acts on a "more" or "fewer" link that controls the length (the number of visible
//mods) of an IMM. The intent is to to avoid dropping down a confusingly long IMM by focusing on
// the most significant mods. If there are a sufficient number of mods in a page's IMM and some 
//of them have arbitrariy labeled themselves as "secondary". The user can choose whether to add
//the secondary mods. Mods that specify an IMM on a given page but don't do very much to a page
//can arbitrarily label themseves as secondary.
function rrimmMoreClick(event) {
	$('.more').toggle();
	event.stopPropagation();
	return false;
}

//////////////////////////////////////////////////
//Onclick event handler to open a TNG Wiki page as a popup. It acts on:
//- The mod name and "W" icon that serve as the mod's heading within an IMM.
//- An identical heading in each MSB.
//- An IMM's "Mods Options" entry in which case the menu entry specifies the HTML anchor for
//  the "Mod Options" section within the wiki article.
function rrimmOpenWikiPage(article, anchor='') {
	if (anchor) anchor="#"+anchor;
	newwindow = window.open('https://tng.lythgoes.net/wiki/index.php?title='+article+anchor, 'wikiwindow', 'height=600, width=780, top=50, left=100, resizable=yes, scrollbars=yes, status=yes');
	newwindow.focus();
	return false;
} //end function rrInnerMenuOpenWikiPage

//////////////////////////////////////////////////
//Handles an IMM "change mod options" link. Pops up a window that contains the Admin General Settings
//form and opens the mod's MSB, but no other subsections of the form or other MSBs.
// Arguments:
//- configprogram - deprecated. All MSBs are not in admin_genconfig.php
//- subform - deprecated. All MSB's are now in the "Mod Settings Blocks" subform. It takes on
//          the constant value "robin13", which is the element ID of the entire "Mod Settings Blocks"
//          subform within admin_genconfig.php, to which the Mods Settings Blocks mod has added
//          a document.ready function that opens the specified subform, and, potentially a
//          specified MSB 
//- modid - Identifies the MSB to be opened. It is a variant of the mod name, in all-lower-case,
//          and without spaces. It is passed to admin_genconfig.php, which will open the
//          specified MSB.. If it is missing, the entire "Mod Settings Blocks" subform 
//          within the General Settings form is opened.
//The editor is invoked as a popup page.
function rrimmOpenConfigPage(configprogram, subform='', modid='') {
	if (configprogram.indexOf('.php') == -1)
		configprogram += '.php';
	if (!subform) {
		if (configprogram == 'admin_genconfig.php') subform = 'robin13';
		else if (configprogram == 'admin_pedconfig.php') subform = 'robin13';
	}
	newwindow = window.open(configprogram+"?mod="+modid+'&rrmsbPopup=1', 'optionswindow', 'height=600, width=780, top=50, left=100, resizable=yes, scrollbars=yes, status=yes');
	newwindow.focus();
	return false;
} //end function rrimmOpenConfigPage

//////////////////////////////////////////////////
//Onclick handler for an Inner Mod Menu "What has changed" link that specfies an arbitrary URL.
//This function does not need to know the mod name, because it can't do anything with it.
function rrimmOpenOtherPage(configprogram) {
	newwindow = window.open(configprogram, 'otherwindow', 'height=600, width=780, top=50, left=100, resizable=yes, scrollbars=yes, status=yes');
	newwindow.focus();
	return false;
} //end function rrimmOpenOtherPage

//////////////////////////////////////////////////
//Onclick handler for an Inner Mod Menu "What has changed" link that specifies the ID of an HTML
//block within the page.  It loads the contents of that block into a TNG Litbox within the page.
//Arguments:
// element - an identfier that is used as the prefix for three HTML elements (within the page)
//           whose ID suffixes indicate they contain the Litbox heading, body text, or footer
// width, height - optional arguments that specify the Litbox's size.
function rrimmPopupElement(modname, element, width, height) {
	if (element.substring(0,1) != '#')
		element = '#' + element;
	var content = "<div class='rrimmLitBox'>" + $(element).html() + "</div>";
	var title = 'Changes made by '+modname;
	if (!width) width=500;
	if (!height) height=500;
	new LITBox(content,{type:'alert', width:width, height:height, overlay:false, title:title});
	return false;
} //end function rrimmPopupElement

//////////////////////////////////////////////////
//Onclick handler for the Inner Mod Menu "What has changed" link. It opens a TNG Litbox
//(within the page) that contains text specified within that page.
function rrInnerModPopupText(modname, content, width, height) {
	var content = "<div class='rrimmLitBox'>" + content + "</div>";
	var title = 'Changes made by '+modname;
	if (!width) width=500;
	if (!height) height=500;
	new LITBox(content,{type:'alert', width:width, height:height, overlay:false, title:title});
	return false;
} //end function rrInnerModPopupText

//////////////////////////////////////////////////
//Onclick handler for the Inner Mod Menu "What has changed" link It loads an arbitrary
//URL in a pop up window.
function rrimmPopupElement(modname, element, width, height) {
	if (element.substring(0,1) != '#')
		element = '#' + element;
	var content = "<div class='rrimmLitBox'>" + $(element).html() + "</div>";
	var title = 'Changes made by '+modname;
	if (!width) width=500;
	if (!height) height=500;
	new LITBox(content,{type:'alert', width:width, height:height, overlay:false, title:title});
	return false;
} //end function rrimmPopupElement

