<?php
##### rrmsb_lib.php, installed by ###Mod Settings Block, by Robin Richmond-
/* This file in Included by genlib.php and adminlib.php in their header functions, where most of
every TNG prge's native <link> and <script> tags are generated. Its functions are

1. rrmsb_InitializeIMM_and_FB - Defines default mod settings values & loads .js files.
2. rrimmBuildInnerModMenu - Called from programs to define their IMMs
3. function rrimmNewTab($modname) - Called from programs when a mod has defined a new tab

########################################################################
/* rrmsb_InitializeIMM_and_FB - Initialization function called from genlib.php
and adminlib.php immediately after their header functions Include this file.
What it does:
1. Initialize the FB mod setting & loads the Field Buttong (FB) .js file.
   When FB was a separate mod, programs that used FBs had to load the FB js.file.
   They used the $rrButtonsAlreadyInstalled to make sure that it was loaded only once.
   (It's too bad that <script> tags don't have the equivalent of include_once)
   Now that the MSB mod changes adminlib.php and genlib to Include this file and call
   this function, the FB script is loaded for ALL TNG `programs and mods no longer
   need to load it. But we're still using that flag because some older mods still
   try to load it themselves. 
2. Load the IMM .js library, initialize the IMM mod settings, and define javascript
   globals that allow the IMM Mod settings to be used in the IMM .js library. 
   setting so they can be used in the external js file for IMMs. That file
*/ #################################################
function rrmsb_InitializeIMM_and_FB() {
	global $rrconfig, $admtext, $text, $cms;
	#Default value for the FB mod setting 
	if (empty($rrconfig['FieldButtonFlags']))
		$rrconfig['FieldButtonFlags'] = "1,1,1,1";
	if (empty($GLOBALS['rrButtonsAlreadyInstalled'])) { #This flag should always be unset
		echo "<script id='rrfblib' type='text/javascript' src='js/rrmsb_fieldbuttons.js'></script>\n";
		echo "<script>
			rrButtonsSystemSettings ('{$GLOBALS['admtext']['rrfb-buttonlabels']}', '{$rrconfig['FieldButtonFlags']}' );
		</script>\n";
		$GLOBALS['rrButtonsAlreadyInstalled'] = 1; #Tell other all programs that FB has been initialized
	}
	#Default mod settings for Inner Mod Menus.
	if (!isset($rrconfig['MSB-IMMLocation'])) $rrconfig['MSB-IMMLocation'] = 'innermenu';
	if (!isset($rrconfig['MSB-IMMLabelRadio'])) $rrconfig['MSB-IMMLabelRadio'] = 'long';
	if (!isset($rrconfig['MSB-IMMLabelOther'])) $rrconfig['MSB-IMMLabelOther'] = 'Mod Info';
	switch ($rrconfig['MSB-IMMLabelRadio']) {
		case "long": $rrconfig['InnermenuLabel'] = $admtext['rrmsb-longlabeltext'];
			break;
		case "short": $rrconfig['InnermenuLabel']= $admtext['rrmsb-shortlabeltext'];
			break;
		default: $rrconfig['InnermenuLabel'] = $rrconfig['MSB-IMMLabelOther'];
	}
	#Create global Javascript variables that will be used in the document.ready function below
	echo "
	<script>
	var rrconfig = Array();
	rrconfig['MSB-IMMLocation'] = \"{$rrconfig['MSB-IMMLocation']}\";
	rrconfig['InnermenuLabel'] = \"{$rrconfig['InnermenuLabel']}\";
	rrconfig['rrimm-moremods'] = \"{$text['rrimm-moremods']}\";
	rrconfig['rrimm-fewermods'] = \"{$text['rrimm-fewermods']}\";
	rrconfig['rrimm-onlyadmins'] = \"{$text['rrimm-onlyadmins']}\";
	</script>\n";
} #end function rrInitializeFieldButtons

########################################################################
/* rrimmBuildInnerModMenu - Generate the HTML code for Inner Mod Menu links.
Since a program can be modified by more than one mod, more than one call to the
function can be inserted into a program, and the Inner Mod Menu can contain links
for more than one mod.
Input:
  $modname - (I'll make you guess)
  $haswikioptions - Truthy if there is a section in the mod's Wiki article that
     describes the mod's options. If its length is >1, then it is presumed to be
     the heading in the article. Otherwise, the heading defaults to 'Mod_Options'
  $configprogram - The Admin>>Setup program through which this mod's options can be
     edited. If non-empty, the function creates a link to the mod's options.
  $subform - The subform where this mods options are placed in the configuration program.
       If $configprogram is empty, this option is ignored.
       This value is only relevant to the two configuration programs that have subforms.
       If it is missing, and one of those two program was specified in $configprogram,
       then it defaults to a specific subform in the that configuration program.
  $helpstring - A strings whose contents are descrbied by $type.
  $type - 'help' => the filename or path and filename of a TNG help page
        - 'url' => an URL - fully qualified or relative
        - 'element' => the id of an HTML element that contains the text
        - 'text' - The text to be displayed
  $wikiname - The mod wiki article name, if it is different from the mod name. With
      my mods, this is not likely to be needed, but you never know.
Return value:
  The fully-marked-up HTML code for the menu, ready to be placed in the Inner Menu,
  in a div with class='innermodmenu'.
*/ #######################################################################
function rrimmBuildInnerModMenu($modname, $haswikioptions=0, $configprogram='', $subform='',
	$helpstring='', $type='help', $width=450, $height=400, $secondary=0) {
	if (!$GLOBALS['allow_admin']) return ''; ####Early exit - user must be an admin
	global $admtext, $text, $helplang;
	if (!$width) $width=450;
	if (!$height) $height=400;

	#Always use the mod name as a heading. Define it as a link so that it has the right styling.
	#on the same line as the heading, add a Wiki icon that pops up the mod's Wiki article.
	$html = "<div class='rrimmMenu' style='display:none;' secondary='$secondary'>";
	$html .= "<a href='#' onclick=\"return rrimmOpenWikiPage('$modname');\"";
	$html .= " class='rrimmWikiLink nw'>$modname";
	$html .= "&nbsp;<img src='img/rrmodsettingsblocks_wiki.gif' class='rrimmWikIcon'";
	$html .= " onclick=\"return rrimmOpenWikiPage('$modname');\"></a><br>";

	if ($haswikioptions) {
		#Add a link that pops up the mod's wiki article, positioned to a Mod Options section.
		if (strlen($haswikioptions)>1)
			$anchor = str_replace(' ', '_', $haswikioptions);
		else $anchor = "Mod_Options";
		$html .= "<div class='nw'>&emsp;<a href='#' class='rrimmlink' onclick=\"return rrimmOpenWikiPage('$modname','$anchor');\">{$text['rrimm-optionshelp']}</a></div>";
	}
	if ($configprogram) {
		#Add a link to the mod options editor. Allow the required 'admin_' prefix and
		#'php' file extension to be omitted.
		if (substr($configprogram,0,6) != 'admin_') $configprogram = "admin_$configprogram";
		if (substr($configprogram, -4) != '.php') $configprogram .= '.php';
		$modid = str_replace(' ', '', $modname);
		$html .= "<div class='nw'>&emsp;<a href='#' class='rrimmlink' onclick=\"return rrimmOpenConfigPage(
			'$configprogram', '$subform', '$modid');\">{$text['rrimm-changeoptions']}</a></div>";
	}

	if ($helpstring) {
		#Define a link to the relevant help document. $type tells us what is in $helpstring.
		#If $helpstring contains "_help.php", it's a TNG help file, which might not have the help path.
		#Otherwise, if $helpstring<100 characters, assume that it is a URL.
		#Otherwise, treat it as text to be displayed in a LITBox.
		$html .= "<div class='nw'>&emsp;<a href='#' class='rrimmlink' ";
		if ($type == 'help') {
			#Assume this is a TNG help page, and add the language
			if (strpos($helpstring,'/') === false) $helpstring = "$helplang/$helpstring";
			$html .= "onclick=\"return openHelp('$helpstring');\"";
		} elseif ($type=='url') {
			# some other help page
			$html .= "onclick=\"return rrimmOpenOtherPage('$helpstring');\"";
		} elseif ($type == 'elementID' || $type=='ID' || $type=='element') {
			# The contents of an HTML element
			$html .= "onclick=\"return rrimmPopupElement('$modname', '$helpstring', $width, $height);\"";
		} else { #HTML text
			$helpstring = addslashes($helpstring);
			$html .= "onclick=\"return rrInnerModPopupText('$modname', '$helpstring', $width, $height);\"";
		}
		$html .= ">{$text['rrimm-whatchanged']}</a></div>";

	}
	return $html . "</div>";
} #end function rrimmBuildInnerModMenu

##########################################################################
##########################################################################
/* rrimmNewTab - Places a flag (a question mark) on tab menu items that
are added by mods. It is called as part of the tab's label. When the user
clicks on the flag, it displays the name of the mod that created it.
This function is the only code of any sort that supports  that flags new tabs (in a program's standard
Tab Menu) that are created by a mod. The flag is an asterisk at the end of the tab label.
The title text of the asterisk is 'Created by {modname}'.
This file contains no Javascript or CSS, so it can be included in programs, such as several Mod Manager programs,
that generate Inner Mod Menu links before any HTML code has been generated.
*/
########################################################################
function rrimmNewTab($modname) {
	global $text;
	$html = "<div class='rrimmNewTab'><div>&nbsp;*<div
		class='rrimmNewModname'>{$text['rrimm-installedby']} $modname</div></div></div>";
	return $html;
} #end function rrimmNewTab
?>
