<?php
##### rrmsb_showmodnames.php, installed by ###SMod Settings Blocks, by Robin Richmond
# (Previously installed by Inner Mod Menus, which is now part of Mod Settings Blocks.)
# This Include file contains code that displays the names of mods that have affected
# the current TNG program. It is Included in footer functions in genlib.php (for end-user programs)
# and in adminlib.php (for admin programs).
# See the .cfg file and the Wiki article for more details.
#############################################################

# Call the function only if there are mod names to list and the user is an administrator.
if (is_array($GLOBALS['tngModNames']) && $GLOBALS['allow_admin']) {
	if (!isset($GLOBALS['rrconfig']['ShowModNamesButton']))
		$GLOBALS['rrconfig']['ShowModNamesButton'] = 0;
	echo showRegisteredModNames();
}

##########################################
function showRegisteredModNames() {
	global $tngModNames, $text, $tngprint;
	global $rrconfig;
	$modstring = ""; #The output string
	# Send the mod names to a comment if we're not going to display them.
	# Do not display them on pages that are formatted for printing
	if (empty($tngprint) && $rrconfig["ShowModNamesButton"]) {
		# Display the buttons
		$modstring .= "<div class='normal ' style='float:left;'>
			<button class='rrShowModNames' title=\"{$text['rrsmn-buttonhelp']}\"
				onclick=\"$('.rrShowModNames').toggle();return false;\">{$text['rrsmn-showmods']}</button>
			<button class='rrShowModNames' style='display:none;'
				onclick=\"$('.rrShowModNames').toggle();return false;\">{$text['rrsmn-hidemods']}</button>
			</div>\n";

		# Generate the mod list, in a hidden div
		$modstring .= "<div id='modnamelist' class='rrShowModNames lightback' style='display:none;'>
			<header><b>{$text['rrsmn-heading1']}<br>{$text['rrsmn-heading2']}</b></header>" .
			listOfMods('visible') . "</div>\n";
	} else { # Send mod names to an HTML comment
		$modstring .= "<!-- *********** {$text['rrsmn-heading1']}: **********" .
			listOfMods('hidden') . "\n******************************************* -->\n";
	}
	return $modstring;
} # End of function showRegisteredModNames

########################################################
# Structural function called by showRegisteredModNames to build a list of mods
function listOfMods($outputType) {
	global $tngModNames;

	foreach ($tngModNames as $modname => $modinfo) {
		#Some mod names in $tngModMames are prefixed with "###"
		$realmodname = trim($modname, '#');
		# Build another array, $modlist, that will be sorted by the modname without leading ###
		foreach ($modinfo as $filename => $version)
			$modlist[$realmodname][$filename] = $version;
	}
	#Build a comma-delimited string of the mod changes, sorted by mod and filename
	ksort($modlist);
	$html = $moddelimiter = '';

	foreach ($modlist as $modname => $modchanges) {
		$wikiurl = 'http://tng.lythgoes.net/wiki/index.php?title=' . str_replace(' ','_',$modname);
		$highestversion = '';
		$filestring = $filedelimiter = '';
		foreach ($modchanges as $filename => $version) {
			#In case different files edited by the same mod have different version #s...
			#Make sure that alpha comparison between mod version numbers (e.g. v9 and v10a)
			#by making sure that the numeric part of the version # is two digits long/
			#Make the version # sortable
			$vnum = $version;
			if ($version < 10) $version = "0$version";
			if ($version > $highestversion)
				$highestversion = $version;

			$filestring .= $filedelimiter . $filename;
			$filedelimiter = ',';
		}
		if (substr($highestversion,0,1)=='0')
			$highestversion = substr($highestversion,1);
		if ($outputType == "visible") {
			$html .= "<li><a href='$wikiurl' class='rrShowModsMod' target='_blank'>$modname v$highestversion</a>
				&ndash; $filestring</li>\n";
		} else { #Generate an HTML comment
			$html .= "\n$wikiurl v$highestversion: $filestring";
		}
		$moddelimiter = ', ';
	}
	if ($outputType == "visible") $html = "<ul style='clear:both;'>$html</ul>\n";
	return $html;
} #End of function listOfMods

?>
<script>
$(function() {
	$('.rrShowModsMod').click(function() {
		$(this).children('div').toggle();
	});
});
</script>

